
// location of mathjax files.


var nagmathjax= ((window.location.protocol=="https:") ? "https" : "http" ) +
    "://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0/";

// var nagmathjax=""../mathjax/";

var nagusecookies = 1 // set to anything else to stop use of cookies





var createCookie = function(name, value, days) {
    if(nagusecookies==1){
    var expires;
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toGMTString();
    }
    else {
        expires = "";
    }
    document.cookie = name + "=" + value + expires + "; path=/";
    }
}

function getCookie(c_name) {
    if (document.cookie.length > 0) {
        c_start = document.cookie.indexOf(c_name + "=");
        if (c_start != -1) {
            c_start = c_start + c_name.length + 1;
            c_end = document.cookie.indexOf(";", c_start);
            if (c_end == -1) {
                c_end = document.cookie.length;
            }
            return unescape(document.cookie.substring(c_start, c_end));
        }
    }
    return "";
}



function hasSVG () {
return !! document.createElementNS &&
       !! document.createElementNS (
             'http://www.w3.org/2000/svg',
             "svg")
      .createSVGRect;
}




function getmathnode() {
    var mmlnodea = document.getElementsByTagName("math");
    var mmlnode = [];
    for( var i = 0; i < mmlnodea.length; i++ ) {
        mmlnode[mmlnode.length] = mmlnodea[i];
    }
    return mmlnode;
}



function doMathIE9() {
    var mmlnode = getmathnode();
    for (var i=0; i<mmlnode.length; i++) {
        var parent = mmlnode[i].parentNode;
        if(parent!=null){
            var str=parent.innerHTML;
	    if(str!=undefined) {
            str = str.replace(/xmlns=.http:\/\/www.w3.org\/1998\/Math\/MathML./ig,'');
            str = str.replace(/<\?XML:NAMESPACE[^<>]*>/ig,'');
            str = str.replace(/<\/(none|mprescripts|mspace)[^<>]*>/ig,'');
            str = str.replace(/<(none|mprescripts|mspace)([^<>]*)>/ig,'<$1$2></$1>');
            str = str.replace(/<(mtd)([^<>]*)>(?=\s*<mtd)/ig,'<$1$2></$1>');
            str = str.replace(/(<\/mtd>)+<\/mtr>/ig,'</mtd></mtr>');
            parent.innerHTML = (str);
	    } 
        }
    }

    doMathJax();
}

function SVGpng() {
    var svgnodea = document.getElementsByTagName("svg");
    var svgnode = [];
    for( var i = 0; i < svgnodea.length; i++ ) {
        svgnode[svgnode.length] = svgnodea[i];
    }
      for (var i=0; i<svgnode.length; i++) { 
        var newnode = 
            document.createElement("img");
          var d1=svgnode[i].parentNode;
          var d2=d1.parentNode;
          newnode.setAttribute("src","../figures/" + d2.getAttribute("id") + ".png");
          d2.replaceChild(newnode,d1);
    }
}



function doMathJax() {
    if(!(hasSVG())) {
	SVGpng();
    }
   var scr=document.createElement("script");
   scr.setAttribute("src",nagmathjax + "MathJax.js?config=TeX-AMS-MML_SVG");
   document.getElementsByTagName("head")[0].appendChild(scr);
   
}




// TOC handler
function showLevel(id,force=false){
    var thisLevel = document.getElementById(id);
    var thisplus = document.getElementById(id +'plus');
    var thisminus = document.getElementById(id + 'minus');
    if(force || getComputedStyle(thisLevel).getPropertyValue("display") != "block"){
	thisLevel.style.display = "block";
	thisplus.style.display = "none";
	thisminus.style.display = "inline";
	thisLevel.parentNode.scrollIntoView();
    } else {
	thisLevel.style.display = "none";
	thisminus.style.display = "none";
	thisplus.style.display = "inline";
    }
}

function ksearch (t,e) {
    if (e.keyCode == 13) {
	document.location='../indexes/kwic.html?q='+t.value.replace(/[ ,]+/g, '+');
	return false;
    }
}




function showName (nd,interf,n) {
    createCookie("nagname-" + interf,n,100);
    var nagnameslist=document.getElementsByClassName("c-name");
    for (var i=0, max=nagnameslist.length; i < max; i++) {
	if(n=="s" || n=="n") {
            nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-s");
	} else if(n=="l" || n=="f"){
	    nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-l");
	}
    }
    var nagnamesul=document.getElementsByClassName("nameslist");
     for (var i=0, max=nagnamesul.length; i < max; i++) {
	 sortUlList(nagnamesul[i]);
     }
    nagnameslist=document.getElementsByClassName("r-name");
    for (var i=0, max=nagnameslist.length; i < max; i++) {
	if(n=="s") {
            nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-s");
	} else if(n=="l"){
	    nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-l");
	} else if(n=="f"){
	    nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-f");
	} else if(n=="n" && nagnameslist[i].getAttribute("data-n")){
	    nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-n");
	}
    }
    var nagnamesul=document.getElementsByClassName("tableconts");
     for (var i=0, max=nagnamesul.length; i < max; i++) {
	 sortUlList(nagnamesul[i]);
     }
}

// not necessarily a ul sorting li (eg works with tbody sorting row)
function sortUlList(ul){
    var newul = ul.cloneNode(false);
    var lilist = [];
    for(var i = ul.childNodes.length; i--;){
        if(ul.childNodes[i].nodeName !== '')
            lilist.push(ul.childNodes[i]);
    }
    // Sort 
    lilist.sort(function(a, b){
      if (a.textContent < b.textContent)
        return -1;
      if (a.textContent > b.textContent)
        return 1;
      return 0;
    });
    for(var i = 0; i < lilist.length; i++)
        newul.appendChild(lilist[i]);
    ul.parentNode.replaceChild(newul, ul);
}

var NagInterface="fl";
if (window.location.href.match(/\/clhtml\//)) {
    NagInterface="cl";
} else if (window.location.href.match(/\/cpphtml\//)) {
    NagInterface="cpp";
} else if (window.location.href.match(/\/adhtml\//)) {
    NagInterface="ad";
}


function showSpec (nd,interf,css) {
    var nagspeclist=document.querySelectorAll("div." + css);
    var langs="";
    inps=nd.parentNode.parentNode.getElementsByTagName("input");
    for (var i=0, max=inps.length; i < max; i++) {
	// just needs to work for showfl and showad (would need adjusting for 3 letter cpp)
	if(inps[i].checked) langs=langs+(langs==""?"":",")+inps[i].getAttribute("id").substring(6);
    }
    createCookie("speclang-" + interf,langs,100);
    for (var i=0, max=nagspeclist.length; i < max; i++) {
	if(nd.checked) {
            nagspeclist[i].style.display="block";
	} else {
            nagspeclist[i].style.display="none";
	}
    }
    if(interf=="ad"){
	var cpplist=document.querySelectorAll(".notcpp");
	for (var i=0, max=cpplist.length; i < max; i++) {
	    if(langs=="cpp") {
		cpplist[i].style.display="none";
	    } else {
		if(cpplist[i].nodeName='TR') {
		    cpplist[i].style.display="table-row";
		} else {
		    cpplist[i].style.display="block";
		}
	    }
	}
    }
}

function getQueryVariable(variable)
{
       var query = window.location.search.substring(1);
       var vars = query.split("&");
       for (var i=0;i<vars.length;i++) {
               var pair = vars[i].split("=");
               if(pair[0] == variable){return pair[1];}
       }
       return(false);
}

const NagInterfaces = ["fl","cl","cpp","ad"];

function setSpecLanguage () {
    var lstr=getQueryVariable("spec");
    for(var i = 0;i < 4; i++){
	var thislstr=lstr;
	if(!thislstr) {
	    thislstr=getCookie("speclang-"+NagInterfaces[i]);
	}
	if(thislstr) {
	    var inp;
	    inp=document.getElementById('show' + NagInterfaces[i] +'f90');
	    if(inp != null) inp.checked=false;
	    inp=document.getElementById('show' + NagInterfaces[i] +'c');
	    if(inp != null) inp.checked=false;
	    inp=document.getElementById('show' + NagInterfaces[i] +'cpp');
	    if(inp != null) inp.checked=false;
	}
	var llist=thislstr.split(",");
	for (var j=0; j<llist.length; j++) {
	    inp=document.getElementById('show' + NagInterfaces[i] + llist[j]);
	    if(inp!=null) inp.checked=true;
	}
	inp=document.getElementById('show' + NagInterfaces[i] +'f90');
	if(inp != null) showSpec(inp,NagInterfaces[i],'fspec');
	inp=document.getElementById('show' + NagInterfaces[i] +'cpp');
	if(inp != null) showSpec(inp,NagInterfaces[i],'flcppspec');
	inp=document.getElementById('show' + NagInterfaces[i] +'c');
	if(inp != null) showSpec(inp,NagInterfaces[i],'flcspec');
    }
}

// end of spec picker test

function setNagNames () {
    var ncq=getQueryVariable("names");
    for(var i = 0;i < 4; i++){
	var thisncq=ncq;
	var nc=false;
	if(ncq=="long") {
	    nc="l";
	} else if(ncq=="short") {
	    nc="s";
	} else if(ncq=="full") {
	    nc="f";
	} else if(ncq=="nag") {
	    nc="n";
	} else {
	    nc=getCookie("nagname-" + NagInterfaces[i]);
	}
	if (nc) {
	    var inel=document.getElementById("name" + NagInterfaces[i] + nc);
	    if( inel != null) {
		inel.checked=true;
		showName(inel,NagInterfaces[i],nc);
	    }
	}
    }
}



if ( navigator.userAgent.match(/Gecko\//) && (! navigator.userAgent.match(/Firefox[ /][1-3][^0-9]/))) {
    // native MathML and SVG in current firefox
    window.addEventListener('load', setNagNames, false);
    window.addEventListener('load', setSpecLanguage, false);
} else if ( window.attachEvent && navigator.userAgent.match(/MSIE [6-9][^0-9]/)) {
    window.attachEvent("onload", doMathIE9);
    window.attachEvent("onload", setNagNames);
    window.attachEvent("onload", setSpecLanguage);
} else if ( window.addEventListener) {
    window.addEventListener('load', doMathJax, false);
    window.addEventListener('load', setNagNames, false);
    window.addEventListener('load', setSpecLanguage, false);
} 
